*
*	multi music status display MMDSP v0.29 Rel.10
*
*			driver parts of 'FALDRV'
*

		.include	faldrv.equ
		.include	mmdsp.equ
		.include	doscall.mac


* Global Symbol ------------------------------- *

		.xref	mxdrv_mpf


* Text Section -------------------------------- *

		.offset	DRV_WORK
FAL_WORKADR::	.DS.L	1
FAL_DATAADR:	.DS.L	1

		.cpu	68000
		.text

*
* FALDRV JOB JUMP TABLE
*
FALDRV_ENTRY::
		.DC.W	FALDRV_CHECK-FALDRV_ENTRY
		.DC.W	FALDRV_NAME-FALDRV_ENTRY
		.DC.W	FALDRV_INIT-FALDRV_ENTRY
		.DC.W	FALDRV_SYSSTAT-FALDRV_ENTRY
		.DC.W	FALDRV_TRKSTAT-FALDRV_ENTRY
		.DC.W	FALDRV_GETMASK-FALDRV_ENTRY
		.DC.W	FALDRV_SETMASK-FALDRV_ENTRY
		.DC.W	FALDRV_FILEEXT-FALDRV_ENTRY
		.DC.W	FALDRV_FLOADP-FALDRV_ENTRY
		.DC.W	FALDRV_PLAY-FALDRV_ENTRY
		.DC.W	FALDRV_PAUSE-FALDRV_ENTRY
		.DC.W	FALDRV_CONT-FALDRV_ENTRY
		.DC.W	FALDRV_STOP-FALDRV_ENTRY
		.DC.W	FALDRV_FADEOUT-FALDRV_ENTRY
		.DC.W	FALDRV_SKIP-FALDRV_ENTRY
		.DC.W	FALDRV_SLOW-FALDRV_ENTRY

*
* KEEP CHECK
*
FALDRV_CHECK:
		MOVEM.L	A0/A3/A5-A6,-(SP)
*
		MOVE.L	$84.W,A0
		SUBQ.L	#8,A0
		CMPI.L	#'FALD',(A0)+
		BNE	FALDRV_CHECK2
		CMPI.W	#'RV',(A0)+
		BNE	FALDRV_CHECK2
		CMPI.W	#'29',(A0)+
		BCC	FALDRV_CHECK3
FALDRV_CHECK2:
		MOVEM.L	(SP)+,A0/A3/A5-A6
		MOVEQ.L	#$FF,D0
		RTS

*
* GET FALDRV WORK ADDRESS
*
FALDRV_CHECK3:
		MOVE.L	A6,-(SP)
		FALDRV	_M_GETWORK
		MOVE.L	(SP)+,A3
		MOVE.L	A6,FAL_WORKADR(A3)
		MOVE.L	A5,FAL_DATAADR(A3)
		MOVEM.L	(SP)+,A0/A3/A5-A6
		MOVEQ.L	#$00,D0
		RTS

*
* GET DRIVER NAME
*
FALDRV_NAME:
		PEA.L	FALDRV_NAMESTR(PC)		* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

FALDRV_NAMESTR:
		.DC.B	'FALDRV'
FALDRV_ENDSTR:
		.DC.B	0
		.EVEN

*
* INITIALIZE
*
FALDRV_INIT:
		MOVE.L	A0,-(SP)
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#5-1,D0
FALDRV_INIT21:
		MOVE.B	#4,T_INSTRUMENT(A0)		* FM
		MOVE.W	#12,T_KEYOFFSET(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D0,FALDRV_INIT21

		MOVEQ.L	#3-1,D0
FALDRV_INIT22:
		MOVE.B	#5,T_INSTRUMENT(A0)		* SSG
		MOVE.W	#12,T_KEYOFFSET(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D0,FALDRV_INIT22

* TRACK NUMBER
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#1,D0
FALDRV_INIT3:
		MOVE.B	D0,T_TRACKNO(A0)
		LEA.L	TRST(A0),A0
		ADDQ.W	#1,D0
		CMPI.W	#10,D0
		BCS	FALDRV_INIT3

		CLR.L	TRACK_ENABLE(A6)
		MOVE.W	#242,CYCLETIM(A6)
		MOVE.W	#77,TITLELEN(A6)
		CLR.B	SORCERIAN_FLAG(A6)
*
		LEA.L	FALDRV_ENDSTR(PC),A0
		MOVE.L	A0,SYS_TITLE(A6)
		MOVE.L	(SP)+,A0
		RTS

*
* GET SYSTEM STATUS
*
FALDRV_SYSSTAT:
		MOVEM.L	D1-D2/A0,-(SP)
*
		MOVEQ.L	#$00,D0
		MOVEA.L	FAL_WORKADR(A6),A0
		MOVE.B	M_LOOP_COUNTER(A0),D0
		MOVE.W	D0,SYS_LOOP(A6)

		MOVE.B	M_OPNTIM(A0),D0
		MOVE.W	D0,SYS_TEMPO(A6)

		MOVE.B	M_STOP_FLAG(A0),D0		* ttO
		SEQ.B	D1				* D0.B : $00=PLAY, $83=STOP
		EXT.W	D1				*
		MOVE.W	D1,PLAY_FLAG(A6)
		BTST.L	#0,D0
		SNE.B	D1
		EXT.W	D1
		MOVE.W	D1,PLAYEND_FLAG(A6)		* tItO
*
		MOVEM.L	(SP)+,D1-D2/A0
		RTS

*
* GET TRACK STATUS
*
FALDRV_TRKSTAT:
		MOVEM.L	D1/A0,-(SP)
*
		BSR	CHECK_DATAEND

* GET FM 1-3 PART STATUS
		MOVEM.L	D1-D3/D5-D7/A0-A3,-(SP)		* FM 1-3
		LEA.L	CHST_BF(A6),A0
		MOVEA.L	FAL_WORKADR(A6),A2
		LEA.L	M_CH1(A2),A2
		LEA.L	TRACK_STATUS(A6),A3
		MOVEQ.L	#3-1,D7
FALDRV_TRKSTAT2:
		BSR	SET_KEYBOARD_STATUS
		LEA.L	CHST(A0),A0			* next MMDSP CHANNEL BUFFER
		LEA.L	$20(A2),A2			* next FALDRV WORK ADDRESS
		LEA.L	TRST(A3),A3			* next MMDSP TRACK BUFFER
		DBRA.W	D7,FALDRV_TRKSTAT2

* IF 'OPNA DATA', GET FM4-5 STATUS
		MOVEA.L	FAL_DATAADR(A6),A2
		MOVE.W	(A2),D0
		BEQ	FALDRV_TRKSTAT3
		ADDQ.W	#1,D0				* D0.W = FFFF
		BNE	FALDRV_TRKSTAT5
FALDRV_TRKSTAT3:
		LEA.L	CHST_BF+(CHST*3)(A6),A0
		MOVEA.L	FAL_WORKADR(A6),A2
		LEA.L	M_CH7(A2),A2
		LEA.L	TRACK_STATUS+(TRST*3)(A6),A3
		MOVEQ.L	#2-1,D7
FALDRV_TRKSTAT4:
		BSR	SET_KEYBOARD_STATUS
		LEA.L	CHST(A0),A0			* next MMDSP CHANNEL BUFFER
		LEA.L	$20(A2),A2			* next FALDRV WORK ADDRESS
		LEA.L	TRST(A3),A3			* next MMDSP TRACK BUFFER
		DBRA.W	D7,FALDRV_TRKSTAT4

* GET SSG PART STATUS
FALDRV_TRKSTAT5:
		LEA.L	CHST_BF+(CHST*5)(A6),A0
		MOVEA.L	FAL_WORKADR(A6),A2
		LEA.L	M_CH4(A2),A2
		LEA.L	TRACK_STATUS+(TRST*5)(A6),A3
		MOVEQ.L	#3-1,D7
FALDRV_TRKSTAT6:
		BSR	SET_KEYBOARD_STATUS
		LEA.L	CHST(A0),A0			* next MMDSP CHANNEL BUFFER
		LEA.L	$20(A2),A2			* next FALDRV WORK ADDRESS
		LEA.L	TRST(A3),A3			* next MMDSP TRACK BUFFER
		DBRA.W	D7,FALDRV_TRKSTAT6
		BSR	SET_TRACK_STATUS
		MOVEM.L	(SP)+,D1-D3/D5-D7/A0-A3
*
		MOVEM.L	(SP)+,D1/A0
		RTS

*
* CHECK DATA END 'FF 00 00'
*
CHECK_DATAEND:
		MOVE.L	FAL_WORKADR(A6),A0
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D1
		LEA.L	M_CH1(A0),A0
CHECK_DATAEND2:
		TST.B	$1F(A0)
		BMI	CHECK_DATAEND3			* b7:1 = END
		BSET.L	D0,D1
CHECK_DATAEND3:
		LEA.L	$20(A0),A0
		ADDQ.B	#1,D0
		CMPI.B	#6,D0
		BCS	CHECK_DATAEND2
*
		TST.B	D1
		BNE	CHECK_DATAEND4			* ǂ̃gbNĂ

		MOVE.W	#-1,PLAYEND_FLAG(A6)		* PLAY END FLAG SET
		FALDRV	_M_STOP
		ADDQ.L	#4,SP				* ! ^[AhXj !
		MOVEM.L	(SP)+,D1/A0
CHECK_DATAEND4:
		RTS

*
*	FALDRV_KEYBOARD_SET
*@\FFALDRV ̃L[{[hXe[^X𓾂
*óFȂ
*QlFbgrsQaeQviUjɂ
*

SET_KEYBOARD_STATUS:
		ST.B	D3				* D3.B : FM/SSG FLAG
		CMPI.B	#3,$1E(A2)			*	 =0 : FM
		BEQ	_FALKBS_1ST			*	<>0 : SSG
		CMPI.B	#4,$1E(A2)
		BEQ	_FALKBS_1ST
		CMPI.B	#7,$1E(A2)
		SEQ.B	D3
_FALKBS_1ST:
		MOVEQ.L	#$00,D6				* D6.L : FLAG BITMAP

_FALKBS_MP:
		MOVE.B	$1F(A2),D0			* $C : MP
		BTST.L	#3,D0
		SNE	D1
		CMP.B	KBS_MP(A0),D1
		BEQ	_FALKBS_q
		BSET.L	#$C,D6
		MOVE.B	D1,KBS_MP(A0)
_FALKBS_q:
		MOVE.B	$09(A2),D0			* $1 : q
		BEQ	_FALKBS_q2
		SUBQ.B	#1,D0
_FALKBS_q2:
		NEG.B	D0
		TAS.B	D0
		CMP.B	KBS_q(A0),D0
		BEQ	_FALKBS_D
		BSET.L	#1,D6
		MOVE.B	D0,KBS_q(A0)

_FALKBS_D:
		MOVE.B	$08(A2),D0			* $2 : D
		EXT.W	D0
		CMP.W	KBS_D(A0),D0
		BEQ	_FALKBS_TONE
		BSET.L	#2,D6
		MOVE.W	D0,KBS_D(A0)

_FALKBS_TONE:
		MOVEQ.L	#$00,D0				* $6 : @
		MOVE.B	5(A2),D0			* el̂
		TST.B	D3
		BEQ	_FALKBS_TONE3

_FALKBS_TONE2:
		MOVE.B	5(A2),D0
		LSR.B	#4,D0
		ADDI.B	#100,D0
_FALKBS_TONE3:
		CMP.W	KBS_PROG(A0),D0
		BEQ	_FALKBS_VOL1
		BSET.L	#6,D6
		MOVE.W	D0,KBS_PROG(A0)

_FALKBS_VOL1:
		MOVE.B	$06(A2),D0			* $7 : @v1
		TST.B	D3
		BNE	_FALKBS_VOL12
		NEG.B	D0				* el̂
		ADDI.B	#127,D0
		ANDI.B	#127,D0
_FALKBS_VOL12:
		CMP.B	KBS_TL1(A0),D0
		BEQ	_FALKBS_VOL2
		BSET.L	#7,D6
		MOVE.B	D0,KBS_TL1(A0)
_FALKBS_VOL2:
		MOVE.B	$1D(A2),D0			* $8 : @v2
		TST.B	D3
		BNE	_FALKBS_VOL22

		MOVEQ.L	#$00,D0				* el̂
		MOVE.B	$06(A2),D1			* @v  v ɕϊ
		NEG.B	D1
		ADDI.B	#127,D1
		MOVEQ.L	#15-1,D2
		LEA.L	FM_VOL_TBL(PC),A1
_FALKBS_VOL21:
		CMP.B	(A1)+,D1
		BLS	_FALKBS_VOL22
		ADDQ.B	#1,D0
		DBRA.W	D2,_FALKBS_VOL21
_FALKBS_VOL22:
		CMP.B	KBS_TL2(A0),D0
		BEQ	_FALKBS_DATA
		BSET.L	#8,D6
		MOVE.B	D0,KBS_TL2(A0)

_FALKBS_DATA:
		MOVEQ.L	#$00,D0				* $9 : DATA
		MOVE.W	$02(A2),D0
		ADD.L	FAL_DATAADR(A6),D0
		CMP.L	KBS_DATA(a0),D0
		BEQ	_FALKBS_KC1
		BSET.L	#9,D6
		MOVE.L	D0,KBS_DATA(A0)

_FALKBS_KC1:
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D1
		MOVE.B	$07(A2),D0			* NOTE NUMBER
		MOVE.B	D0,D1				* OCTAVE.hb|NOTE.lb
		TST.B	D3
		BNE	_FALKBS_KC1S
* KEYCODE FM:
		ANDI.B	#$70,D1
		LSL.W	#7,D1
		ANDI.B	#$0F,D0
		ADD.W	D0,D0
		LEA.L	FNUM_TBL(PC),A1
		MOVE.W	(A1,D0.W),D0
		OR.W	D1,D0
		MOVE.B	$08(A2),D1			* DETUNE
		EXT.W	D1
		ADD.W	D1,D0
		BRA	_FALKBS_KC12

* KEYCODE SSG:
_FALKBS_KC1S:
		LSR.B	#4,D1
		ANDI.B	#$0F,D0
		ADD.W	D0,D0
		LEA.L	FREQ_TBL(PC),A1
		MOVE.W	(A1,D0.W),D0
		MOVE.B	$08(A2),D2
		EXT.W	D2
		ADD.W	D2,D0
*
		TST.B	D1
		BEQ	_FALKBS_KC12
_FALKBS_KC1S2:
		LSR.W	#1,D0
		SUBQ.B	#1,D1
		BNE	_FALKBS_KC1S2
_FALKBS_KC12:
		CMP.W	KBS_KC1(A0),D0			* $A : KC1
		BEQ	_FALKBS_KC2
		BSET.L	#$A,D6
		MOVE.W	D0,KBS_KC1(A0)

_FALKBS_KC2:
		MOVE.W	$1A(A2),D0
		TST.B	D3
		BEQ	_FALKBS_KC22
		MOVE.B	$1C(A2),D1			* rrf̂
		BEQ	_FALKBS_KC22
_FALKBS_KC21:
		LSR.W	#1,D0
		SUBQ.B	#1,D1
		BNE	_FALKBS_KC21
_FALKBS_KC22:
		CMP.W	KBS_KC2(A0),D0			* $B : KC2
		BEQ	_FALKBS_P
		BSET.L	#$B,D6
		MOVE.W	D0,KBS_KC2(A0)

_FALKBS_P:						* $3 : P
		TST.B	D3
		BNE	_FALKBS_PS
* FM
		BSR	GET_BEND
		BRA	_FALKBS_P2
* SSG
_FALKBS_PS:
		MOVE.W	KBS_KC2(A0),D0			* KC2-KC1
		SUB.W	KBS_KC1(A0),D0
		NEG.W	D0
_FALKBS_P2:
		CMP.W	KBS_P(A0),D0
		BEQ	_FALKBS_LOOPE
		BSET.L	#3,D6
		MOVE.W	D0,KBS_P(A0)
		MOVE.W	D0,T_BEND(A3)			* P: ̒lxhW

_FALKBS_LOOPE:
		MOVE.W	D6,KBS_CHG(A0)			* ωtOZbg
		RTS

*
* SET KEYBOARD STATUS
*
SET_TRACK_STATUS:
		MOVEQ.L	#$00,D2				*gbNt󋵎o
		MOVEQ.L	#$00,D0
		MOVEA.L	FAL_WORKADR(A6),A0
* FM  1-3
		LEA.L	M_CH1(A0),A1
_GET_MASKST1:
		BSR	GET_MASKSTAT
		LEA.L	$20(A1),A1
		ADDQ.W	#1,D0
		CMPI.W	#3,D0
		BCS	_GET_MASKST1
* FM  4-5
		LEA.L	M_CH7(A0),A1
_GET_MASKST2:
		BSR	GET_MASKSTAT
		LEA.L	$20(A1),A1
		ADDQ.W	#1,D0
		CMPI.W	#5,D0
		BCS	_GET_MASKST2
* SSG 1-3
		LEA.L	M_CH4(A0),A1
_GET_MASKST3:
		BSR	GET_MASKSTAT
		LEA.L	$20(A1),A1
		ADDQ.W	#1,D0
		CMPI.W	#8,D0
		BCS	_GET_MASKST3

		MOVE.L	TRACK_ENABLE(A6),D0
		MOVE.L	D2,TRACK_ENABLE(A6)
		EOR.L	D2,D0
		MOVE.L	D0,TRACK_CHANGE(A6)

* GET FM1-3 STATUS
		MOVEA.L	FAL_WORKADR(A6),A0
		LEA.L	M_CH1(A0),A1
		LEA.L	M_KEYON_FLAG(A0),A2
		LEA.L	TRACK_STATUS(A6),A3
		MOVEQ.L	#3-1,D7				* FM 1-3
SET_TRACK_STATUS2:
		BSR	GET_TRACK_FM
		LEA.L	$20(A1),A1
		LEA.L	TRST(A3),A3
		DBRA.W	D7,SET_TRACK_STATUS2

* IF 'OPNA' DATA, GET FM4-5 STATUS
		MOVEA.L	FAL_DATAADR(A6),A1
		MOVE.W	(A1),D0
		BEQ	SET_TRACK_STATUS21
		ADDQ.W	#1,D0				* D0.W = FFFF
		BNE	FALDRV_TRKSTAT3
SET_TRACK_STATUS21:
		LEA.L	M_CH7(A0),A1
		LEA.L	M_KEYON_FLAG+5(A0),A2
		LEA.L	TRACK_STATUS+(TRST*3)(A6),A3
		MOVEQ.L	#2-1,D7				* FM 4-5
SET_TRACK_STATUS22:
		BSR	GET_TRACK_FM
		LEA.L	$20(A1),A1
		LEA.L	TRST(A3),A3
		DBRA.W	D7,SET_TRACK_STATUS22

SET_TRACK_STATUS3:
		LEA.L	M_CH4(A0),A1
		LEA.L	M_KEYON_FLAG+3(A0),A2
		LEA.L	TRACK_STATUS+(TRST*5)(A6),A3
		MOVEQ.L	#3-1,D7				* SSG 1-3
SET_TRACK_STATUS31:
		TST.W	D7
		BNE	SET_TRACK_STATUS32
		ADDQ.L	#2,A2
SET_TRACK_STATUS32:
		BSR	GET_TRACK_SSG
		LEA.L	$20(A1),A1
		LEA.L	TRST(A3),A3
		DBRA.W	D7,SET_TRACK_STATUS31
		RTS

*
* GET TRACK MASK STATUS
*
* IN	D0.L : TRACK NUMBER
*	A1.L : FAKDRV CHANNEL WORK
* OUT	D2.L : MASK STATUS
*
GET_MASKSTAT:
		TST.B	$1F(A1)				* b7=ON:TRACK END
		BMI	GET_MASKSTAT2
		BTST.B	#6,$10(A1)			* b6=ON:MASK ON  OFF:MASK OFF
		BNE	GET_MASKSTAT2
		BSET.L	D0,D2
GET_MASKSTAT2:
		RTS

*
* GET BEND RANGE
*
* IN	A0.L : mmdsp KEYBOARD WORK
* OUT	D0.W : BEND RANGE
*
GET_BEND:
		MOVEM.L	D2-D7,-(SP)
		MOVE.W	KBS_KC1(A0),D0
		MOVE.W	D0,-(SP)
		BSR	GET_BLOCK
		MOVE.W	D0,D4			* D4.W : KC1 BLOCK
		MOVE.W	(SP)+,D0
		MOVE.W	#%00000111_11111111,D1
		AND.W	D1,D0
		MOVE.W	D0,D5			* D5.W : KC1 F-Number
*
		MOVE.W	KBS_KC2(A0),D0
		MOVE.W	D0,-(SP)
		BSR	GET_BLOCK
		MOVE.W	D0,D6			* D6.W : KC2 BLOCK
		MOVE.W	(SP)+,D0
		MOVE.W	#%00000111_11111111,D1
		AND.W	D1,D0
		MOVE.W	D0,D7			* D7.W : KC2 F-Number

* CHECK BLOCK DIFF.
		MOVE.W	#$225,D0		* D0.W : $48F(B)-$26A(C)
		MOVEQ.L	#$00,D3			* D3.W : BLOCK DIFF
GET_BEND2:
		CMP.W	D4,D6
		BEQ	GET_BEND4
		BCS	GET_BEND3

* KC1 < KC2 : ADD 1 BLOCK
		ADD.W	D0,D3
		ADDQ.W	#1,D4
		BRA	GET_BEND2

* KC1 > KC2 : SUB 1 BLOCK
GET_BEND3:
		SUB.W	D0,D3
		SUBQ.W	#1,D4
		BRA	GET_BEND2

GET_BEND4:
		SUB.W	D5,D7			* (KC2 F-Num)-(KC1 F-Num)
		ADD.W	D7,D3
		MOVE.W	D3,D0
		MOVEM.L	(SP)+,D2-D7
		RTS

*
* GET BLOCK
*
* IN	D0.W : BLOCK + F-Number
* OUT	D0.W : BLOCK(0-7)
* BRK	D1
*
GET_BLOCK:
		ANDI.W	#%00111000_00000000,D0
		MOVEQ.L	#8+3,D1
		LSR.W	D1,D0
		RTS

*
* GET FM TRACK STATUS
*
* IN	A0.L : FALDRV WORK AREA
*	A1.L : FALDRV CHANNEL WORK
*	A2.L : KEYON WORK
*	A3.L : MMDSP TRACK STATUS WORK
*
GET_TRACK_FM:
		MOVEQ.L	#$00,D5
		MOVE.L	D5,T_STCHANGE(A3)		* FLAG RESET

		MOVEQ.L	#$C0,D0				* FM PAN
		TST.B	M_OPNA_MODE(A0)
		BNE	GET_TRACK_FM01
		MOVE.B	$01(A1),D1
		ROL.B	#2,D1
		ANDI.W	#$0003,D1
		MOVE.B	OPNA_PANTBL(PC,D1.W),D0		* PAN ϊ
GET_TRACK_FM01:
		ROL.B	#2,D0
		CMP.W	T_PAN(A3),D0
		BEQ	GET_TRACK_FM10
		MOVE.W	D0,T_PAN(A3)
		BSET.L	#2,D5
GET_TRACK_FM10:
		BSET.L	#1,D5				* FM BEND
		BRA	GET_TRACK_FM50

OPNA_PANTBL:
		.DC.B	$00,$40,$80,$C0


GET_TRACK_FM50:
		MOVEQ.L	#$00,D0
		MOVE.B	$06(A1),D0			* $7 : @v1
		NEG.B	D0				* FM ̏ꍇ
		ADDI.B	#127,D0
		ANDI.B	#$7F,D0
		CMP.B	T_VELOCITY(A3),D0
		BEQ	GET_TRACK_FM51
		MOVE.B	#$01,T_VELCHANGE(A3)
		MOVE.B	D0,T_VELOCITY(A3)

GET_TRACK_FM51:
		MOVEQ.L	#$00,D0				* FM PROGRAM
		MOVE.B	$05(A1),D0
		CMP.W	T_PROGRAM(A3),D0
		BEQ	GET_TRACK_FM40
		MOVE.W	D0,T_PROGRAM(A3)
		BSET.L	#3,D5

GET_TRACK_FM40:
		MOVE.B	(A2),D0				* FM KEYON
		BSET.B	#7,(A2)+
		BNE	GET_TRACK_FM60
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		ANDI.B	#$78,D0
		SEQ.B	D0
		ORI.B	#$FE,D0
		MOVE.B	D0,T_KEYONSTAT(A3)

GET_TRACK_FM60:
		MOVEQ.L	#$00,D0
		MOVE.B	$07(A1),D0			* NOTE.b 4hb OCTAVE
							*	 4lb NOTE
		MOVE.L	A0,-(SP)
		LEA.L	KEY_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_KEYCODE(A3),D0		* FM KEYBOARD
		BEQ	GET_TRACK_FM90
		MOVE.B	#$01,T_KEYCHANGE(A3)
		MOVE.B	D0,T_KEYCODE(A3)

GET_TRACK_FM90:
		MOVE.L	(SP)+,A0
		MOVE.B	D5,T_STCHANGE(A3)
		RTS

*
* GET SSG TRACK STATUS
*
* IN	A1.L : FALDRV CHANNEL WORK
*	A2.L : KEYON WORK
*	A3.L : MMDSP TRACK STATUS WORK
*
GET_TRACK_SSG:
		MOVEQ.L	#$00,D5				* FLAG RESET
		MOVE.L	D5,T_STCHANGE(A3)

		MOVEQ.L	#$C0,D0				* SSG PAN(DUMMY)
		ROL.B	#2,D0
		CMP.W	T_PAN(A3),D0
		BEQ	GET_TRACK_SSG00
		MOVE.W	D0,T_PAN(A3)
		BSET.L	#2,D5

GET_TRACK_SSG00:
		BSET.L	#1,D5				* SSG BEND

GET_TRACK_SSG10:
		MOVE.B	$06(A1),D0			* @v1
*		MOVE.B	$1D(A1),D0			* @v2
		ANDI.W	#$000F,D0
		LEA.L	SSG_TL_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_VELOCITY(A3),D0
		BEQ	GET_TRACK_SSG20
		MOVE.B	#$01,T_VELCHANGE(A3)
		MOVE.B	D0,T_VELOCITY(A3)
GET_TRACK_SSG20:
		MOVEQ.L	#$00,D0				* SSG PROGRAM
		MOVE.B	$05(A1),D0
		LSR.B	#4,D0
		ADDI.B	#100,D0
		CMP.W	T_PROGRAM(A3),D0
		BEQ	GET_TRACK_SSG30
		MOVE.W	D0,T_PROGRAM(A3)
		BSET.L	#3,D5
GET_TRACK_SSG30:
		BTST.B	#6,$10(A1)			* b6=ON:MASK ON  OFF:MASK OFF
		BNE	GET_TRACK_SSG32

		MOVE.B	(A2),D0				* SSG KEYON
		BSET.B	#7,(A2)+
		BNE	GET_TRACK_SSG50
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		ANDI.B	#$78,D0
		SEQ.B	D0
		ORI.B	#$FE,D0
		MOVE.B	D0,T_KEYONSTAT(A3)
		BRA	GET_TRACK_SSG50

* IF SSG MASK
GET_TRACK_SSG32:
		ADDQ.L	#1,A2
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		ST.B	T_KEYONSTAT(A3)

GET_TRACK_SSG50:
		MOVEQ.L	#$00,D0
		MOVE.B	$07(A1),D0
		LEA.L	KEY_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_KEYCODE(A3),D0		* SSG KEYCODE
		BEQ	GET_TRACK_SSG90
		MOVE.B	#$01,T_KEYCHANGE(A3)
		MOVE.B	D0,T_KEYCODE(A3)

GET_TRACK_SSG90:
		MOVE.B	D5,T_STCHANGE(A3)
		RTS

*
* GET TRACK MASK
*
FALDRV_GETMASK:
		MOVE.L	TRACK_ENABLE(A6),D0
		RTS

*
* SET TRACK MASK
*
FALDRV_SETMASK:
		MOVEM.L	D1-D2/A0,-(SP)
		MOVEA.L	FAL_WORKADR(A6),A0
		NOT.L	D1
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D2
FALDRV_SETMASK2:
		MOVE.W	D2,D0
		ADD.W	D0,D0
		MOVE.W	CNVCH_TBL(PC,D0.W),D0
		BTST.L	D2,D1
		BEQ	FALDRV_SETMASK5
* BIT ON  = MASK ON
		BSET.B	#6,$10(A0,D0.W)
		BRA	FALDRV_SETMASK6
* BIT OFF = MASK OFF
FALDRV_SETMASK5:
		BCLR.B	#6,$10(A0,D0.W)
FALDRV_SETMASK6:
		ADDQ.W	#1,D2
		CMPI.B	#8,D2
		BCS	FALDRV_SETMASK2

		MOVEM.L	(SP)+,D1-D2/A0
		RTS

*
* CHANNEL -> M_CHx OFFSET CONVERT TABLE
*
CNVCH_TBL:
		.DC.W	M_CH1,M_CH2,M_CH3,M_CH7,M_CH8	* FM
		.DC.W	M_CH4,M_CH5,M_CH6		* SSG

*
* GET SUPPORT FILE-EXT.
*
FALDRV_FILEEXT:
		PEA.L	FILEEXT_DAT(PC)			* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

FILEEXT_DAT:
.ifdef USE_G_LOADER
		.DC.B	_PIC,'PIC'
		.DC.B	_JPG,'JPG'
.endif
		.DC.B	_OPN,'OPN'
		.DC.B	_MPF,'MPF'
		.DC.B	0
		.EVEN

*
* CHECK & EXEC FILE-EXT.
*
FALDRV_FLOADP:
		MOVEM.L	D1/A1,-(SP)
*
		CMPI.B	#_PIC,D0
.ifdef USE_G_LOADER
		.xref	MXDRV_PIC
		.xref	MXDRV_JPEG
		BEQ	MXDRV_PIC
		CMPI.B	#_JPG,D0
		BEQ	MXDRV_JPEG
.endif
		CMPI.B	#_OPN,D0
		BEQ	FALDRV_OPN
		CMPI.B	#_MPF,D0
		BEQ	mxdrv_mpf
*
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$FF,D0
		RTS

FALDRV_OPN:
		MOVE.W	#0,-(SP)
		MOVE.L	A1,-(SP)
		DOS	_OPEN
		ADDQ.L	#6,SP
		MOVE.W	D0,D1
		BMI	FALDRV_LOADERR

		FALDRV	_M_STOP
		MOVE.L	A1,SYS_TITLE(A6)		***** 97-04-01

		MOVEA.L	FAL_DATAADR(A6),A1
		PEA.L	$4000.W
		PEA.L	$D00(A1)
		MOVE.W	D1,-(SP)
		DOS	_READ
		DOS	_CLOSE
		LEA.L	10(SP),SP

		FALDRV	_M_PLAY_JUMP
FALDRV_LOADOK:
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$00,D0
		RTS

FALDRV_LOADERR:
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$02,D0
		RTS

*
* PLAY
*
FALDRV_PLAY:
		FALDRV	_M_PLAY_JUMP
		RTS

*
* PAUSE / STOP
*
FALDRV_PAUSE:
FALDRV_STOP:
		FALDRV	_M_STOP
		RTS

*
* FADEOUT
*
FALDRV_FADEOUT:
		MOVE.L	D1,-(SP)
		MOVE.W	MMDSP_FADE_SPD(A6),D1
		FALDRV	_M_FADEOUT
		MOVE.L	(SP)+,D1
		RTS

*
* CONTINUE
*
FALDRV_CONT:
		FALDRV	_M_PLAY
		RTS

*
* SKIP
*
FALDRV_SKIP:
		TST.W	D0
		BNE	FALDRV_SKIP2
		CLR.B	$80E.W
		RTS
FALDRV_SKIP2:
		MOVE.B	#9,$80E.W
		RTS

*
* SLOW
*
FALDRV_SLOW:
		TST.W	D0
		BNE	FALDRV_SLOW2
		CLR.B	$80E.W
		RTS
FALDRV_SLOW2:
		MOVE.B	#5,$80E.W
		RTS



		.DATA

*
* OPM KC TABLE
*
KEY_TBL::
*			C   C+  D   D+  E   F   F+  G   G+  A   A+  B   DMY DMY DMY DMY
		.DC.B	$00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$FF,$FF,$FF,$FF
		.DC.B	$0C,$0D,$0E,$0F,$10,$11,$12,$13,$14,$15,$16,$17,$FF,$FF,$FF,$FF
		.DC.B	$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$20,$21,$22,$23,$FF,$FF,$FF,$FF
		.DC.B	$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$FF,$FF,$FF,$FF
		.DC.B	$30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$FF,$FF,$FF,$FF
		.DC.B	$3C,$3D,$3E,$3F,$40,$41,$42,$43,$44,$45,$46,$47,$FF,$FF,$FF,$FF
		.DC.B	$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$50,$51,$52,$53,$FF,$FF,$FF,$FF
		.DC.B	$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F,$FF,$FF,$FF,$FF


*
* OPN F-Number / SSG Freqency TABLE
*
FNUM_TBL::
		.DC.W	$026A,$028F,$02B6,$02DF
		.DC.W	$030B,$0339,$036A,$039E
		.DC.W	$03D5,$0410,$044E,$048F
FREQ_TBL::
		.DC.W	$0EE8,$0E12,$0D48,$0C89
		.DC.W	$0BD5,$0B2B,$0A8A,$09F3
		.DC.W	$0964,$08DD,$085E,$07E6

*
* VOLUME TABLE
*
VOL_DEFAULT::
		.DC.B	085
FM_VOL_TBL::
		.DC.B	087,090,093,095,098,101,103,106
		.DC.B	109,111,114,117,119,122,125,127
SSG_TL_TBL::
		.DC.B	000,016,024,032,040,048,056,064
		.DC.B	072,080,088,096,104,112,120,127



		.END
