*
*	multi music status display MMDSP v0.29 Rel.14
*
*			driver parts of 'SORCERIAN (X1turbo)'
*

		.include	sorcsr.equ
		.include	mmdsp.equ
		.include	doscall.mac


* Global Symbol ------------------------------- *

		.xref	FM_VOL_TBL
		.xref	FREQ_TBL
		.xref	SSG_TL_TBL
		.xref	KEY_TBL
		.xref	mxdrv_mpf


* Text Section -------------------------------- *

		.offset	DRV_WORK
SORCX1_WORKADR:	.DS.L	1
SORCX1_DATAADR:	.DS.L	1
KEYONWK:	.DS.W	8

		.cpu	68000
		.text

*
* SORCX1 JOB JUMP TABLE
*
SORCX1_ENTRY::
		.DC.W	SORCX1_CHECK-SORCX1_ENTRY
		.DC.W	SORCX1_NAME-SORCX1_ENTRY
		.DC.W	SORCX1_INIT-SORCX1_ENTRY
		.DC.W	SORCX1_SYSSTAT-SORCX1_ENTRY
		.DC.W	SORCX1_TRKSTAT-SORCX1_ENTRY
		.DC.W	SORCX1_GETMASK-SORCX1_ENTRY
		.DC.W	SORCX1_SETMASK-SORCX1_ENTRY
		.DC.W	SORCX1_FILEEXT-SORCX1_ENTRY
		.DC.W	SORCX1_FLOADP-SORCX1_ENTRY
		.DC.W	SORCX1_PLAY-SORCX1_ENTRY
		.DC.W	SORCX1_PAUSE-SORCX1_ENTRY
		.DC.W	SORCX1_CONT-SORCX1_ENTRY
		.DC.W	SORCX1_STOP-SORCX1_ENTRY
		.DC.W	SORCX1_FADEOUT-SORCX1_ENTRY
		.DC.W	SORCX1_SKIP-SORCX1_ENTRY
		.DC.W	SORCX1_SLOW-SORCX1_ENTRY

*
* KEEP CHECK
*
SORCX1_CHECK:
		MOVE.L	A0,-(SP)
		MOVE.L	$84.W,A0
		SUBQ.L	#8,A0
		CMPI.L	#'SORC',(A0)+
		BNE	SORCX1_CHECK2
		CMPI.L	#'X1  ',(A0)+
		BEQ	SORCX1_CHECK3
SORCX1_CHECK2:
		MOVE.L	(SP)+,A0
		MOVEQ.L	#$FF,D0
		RTS

*
* GET FALDRV WORK ADDRESS
*
SORCX1_CHECK3:
		SORCSR	_M_GETWORK
		MOVE.L	D0,A0
		MOVE.L	A0,SORCX1_WORKADR(A6)
		MOVE.L	M_WORKTOP(A0),SORCX1_DATAADR(A6)
		MOVE.L	(SP)+,A0
		MOVEQ.L	#$00,D0
		RTS

*
* GET DRIVER NAME
*
SORCX1_NAME:
		PEA.L	SORCX1_NAMESTR(PC)		* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

SORCX1_NAMESTR:
		.DC.B	'SORCERIAN (X1turbo)'
SORCX1_ENDSTR:
		.DC.B	0
		.EVEN

*
* INITIALIZE
*
SORCX1_INIT:
		MOVE.L	A0,-(SP)
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#5-1,D0
SORCX1_INIT2:
		MOVE.B	#4,T_INSTRUMENT(A0)		* FM
		MOVE.W	#12,T_KEYOFFSET(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D0,SORCX1_INIT2

		MOVEQ.L	#3-1,D0
SORCX1_INIT3:
		MOVE.B	#5,T_INSTRUMENT(A0)		* SSG
		MOVE.W	#12,T_KEYOFFSET(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D0,SORCX1_INIT3

* TRACK NUMBER
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#1,D0
SORCX1_INIT4:
		MOVE.B	D0,T_TRACKNO(A0)
		LEA.L	TRST(A0),A0
		ADDQ.W	#1,D0
		CMPI.W	#9,D0
		BCS	SORCX1_INIT4

		CLR.L	TRACK_ENABLE(A6)
		MOVE.W	#292,CYCLETIM(A6)
		MOVE.W	#77,TITLELEN(A6)
		ST.B	SORCERIAN_FLAG(A6)

		LEA.L	KEYONWK(A6),A0		* INITIALIZE KEYON WORK
		MOVEQ.L	#$00,D0
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	(SP)+,A0
		RTS

*
* GET SYSTEM STATUS
*
SORCX1_SYSSTAT:
		MOVEM.L	D1-D2/A0,-(SP)
*
		LEA.L	SORCX1_ENDSTR(PC),A0
		MOVE.L	A0,SYS_TITLE(A6)
		MOVEQ.L	#$00,D0
		MOVEA.L	SORCX1_WORKADR(A6),A0
		CLR.W	SYS_LOOP(A6)

		MOVE.B	M_TEMPO(A0),D0
		MOVE.W	D0,SYS_TEMPO(A6)

		MOVE.B	M_STOP_FLAG(A0),D0	* ttO
		SEQ.B	D1			* D0.B : $00=PLAY, $83=STOP
		EXT.W	D1			*
		MOVE.W	D1,PLAY_FLAG(A6)
		BTST.L	#0,D0
		SNE.B	D1
		EXT.W	D1
		MOVE.W	D1,PLAYEND_FLAG(A6)	* tItO
*
		MOVEM.L	(SP)+,D1-D2/A0
		RTS

*
* GET TRACK STATUS
*
SORCX1_TRKSTAT:
		MOVEM.L	D1-D7/A0-A3/A5,-(SP)

* CHECK DATA END 'FF 00 00'
CHECK_DATAEND:
		MOVE.L	SORCX1_WORKADR(A6),A5
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D1
		LEA.L	M_CH1(A5),A0
CHECK_DATAEND2:
		TST.B	$1F(A0)
		BMI	CHECK_DATAEND3		* b7:1 = END
		BSET.L	D0,D1
CHECK_DATAEND3:
		LEA.L	$20(A0),A0
		ADDQ.B	#1,D0
		CMPI.B	#8,D0
		BCS	CHECK_DATAEND2
*
		TST.B	D1
		BNE	CHECK_DATAEND4		* ǂ̃gbNĂ

		MOVE.W	#-1,PLAYEND_FLAG(A6)	* PLAY END FLAG SET
		SORCSR	_M_STOP
		BRA	SORCX1_TRKSTAT2

* TRACK ALIVE, GET STATUS
CHECK_DATAEND4:
		BSR	SET_KEYBOARD_STATUS
		BSR	SET_TRACK_STATUS
SORCX1_TRKSTAT2:
		MOVEM.L	(SP)+,D1-D7/A0-A3/A5
		RTS

*
*	SORCX1_KEYBOARD_SET
*@\FSORCSR ̃L[{[hXe[^X𓾂
*óFȂ
*QlFbgrsQaeQviUjɂ
*

SET_KEYBOARD_STATUS:
		LEA.L	CHST_BF(A6),A0
		LEA.L	M_CH1(A5),A2
		LEA.L	TRACK_STATUS(A6),A3
		MOVEQ.L	#8-1,D7
_SX1KBS_LOOP:
		MOVEQ.L	#0,D6			* D6.L : FLAG BITMAP

_SX1KBS_MP:
		MOVE.B	$1F(A2),D0		* $C : MP
		BTST.L	#3,D0
		SNE	D1
		CMP.B	KBS_MP(A0),D1
		BEQ	_SX1KBS_q
		BSET.L	#$C,D6
		MOVE.B	D1,KBS_MP(A0)

_SX1KBS_q:
		MOVE.B	$09(A2),D0		* $1 : q
		BEQ	_SX1KBS_q2
		SUBQ.B	#1,D0
_SX1KBS_q2:
		NEG.B	D0
		CMP.B	KBS_q(A0),D0
		BEQ	_SX1KBS_D
		BSET.L	#1,D6
		MOVE.B	D0,KBS_q(A0)

_SX1KBS_D:
		MOVE.B	$08(A2),D0		* $2 : D
		EXT.W	D0
		CMP.W	KBS_D(A0),D0
		BEQ	_SX1KBS_TONE
		BSET.L	#2,D6
		MOVE.W	D0,KBS_D(A0)

_SX1KBS_TONE:
		MOVEQ.L	#$00,D0			* $6 : @
		CMPI.B	#5,$1E(A2)
		BCC	_SX1KBS_TONE2
		MOVE.B	5(A2),D0		* el̂
		BRA	_SX1KBS_TONE3
_SX1KBS_TONE2:
		MOVE.B	5(A2),D0
		LSR.B	#4,D0
		ADDI.B	#100,D0
_SX1KBS_TONE3:
		CMP.W	KBS_PROG(A0),D0
		BEQ	_SX1KBS_VOL1
		BSET.L	#6,D6
		MOVE.W	D0,KBS_PROG(A0)

_SX1KBS_VOL1:
		MOVE.B	$06(A2),D0		* $7 : @v1
		CMPI.B	#5,$1E(A2)
		BCC	_SX1KBS_VOL12
		NEG.B	D0			* el̂
		ADDI.B	#127,D0
		ANDI.B	#$7F,D0
_SX1KBS_VOL12:
		CMP.B	KBS_TL1(A0),D0
		BEQ	_SX1KBS_VOL2
		BSET.L	#7,D6
		MOVE.B	D0,KBS_TL1(A0)
_SX1KBS_VOL2:
		MOVE.B	$1D(A2),D0		* $8 : @v2
		CMPI.B	#5,$1E(A2)
		BCC	_SX1KBS_VOL22

		MOVEQ.L	#$00,D0			* el̂
		MOVE.B	$06(A2),D1		* @v  v ɕϊ
		NEG.B	D1
		ADDI.B	#127,D1
		MOVEQ.L	#15-1,D2
		LEA.L	FM_VOL_TBL(PC),A1
_SX1KBS_VOL21:
		CMP.B	(A1)+,D1
		BLS	_SX1KBS_VOL22
		ADDQ.B	#1,D0
		DBRA.W	D2,_SX1KBS_VOL21
_SX1KBS_VOL22:
		CMP.B	KBS_TL2(A0),D0
		BEQ	_SX1KBS_DATA
		BSET.L	#8,D6
		MOVE.B	D0,KBS_TL2(A0)

_SX1KBS_DATA:
		MOVEQ.L	#$00,D0			* $9 : DATA
		MOVE.W	$02(A2),D0
		ADD.L	SORCX1_DATAADR(A6),D0
		CMP.L	KBS_DATA(A0),D0
		BEQ	_SX1KBS_KC1
		BSET.L	#9,D6
		MOVE.L	D0,KBS_DATA(A0)

_SX1KBS_KC1:
		MOVEQ.L	#$00,D0
		MOVEQ.L	#$00,D1
		MOVE.B	$07(A2),D0
		MOVE.B	D0,D1
*
		CMPI.B	#5,$1E(A2)		* rrf̏ꍇ
		BCC	_SX1KBS_KC1S

* KEYCODE FM
		MOVE.B	D0,-(SP)
		MOVE.W	(SP)+,D0
		MOVE.B	#$14,D0
		MOVE.B	$08(A2),D1
		EXT.W	D1
		ADD.W	D1,D1
		ADD.W	D1,D1				* 96-02-28
		ADD.W	D1,D0
		BRA	_SX1KBS_KC12
* KEYCODE SSG
_SX1KBS_KC1S:
		LSR.B	#4,D1
		ANDI.B	#$0F,D0
		ADD.W	D0,D0
		LEA.L	FREQ_TBL(PC),A1
		MOVE.W	(A1,D0.W),D0
		MOVE.B	$08(A2),D2
		EXT.W	D2
		ADD.W	D2,D0
*
		TST.B	D1
		BEQ	_SX1KBS_KC12
_SX1KBS_KC1S2:
		LSR.W	#1,D0
		SUBQ.B	#1,D1
		BNE	_SX1KBS_KC1S2
_SX1KBS_KC12:
		CMP.W	KBS_KC1(A0),D0		* $A : KC1
		BEQ	_SX1KBS_KC2
		BSET.L	#$A,D6
		MOVE.W	D0,KBS_KC1(A0)

_SX1KBS_KC2:
		MOVE.W	$1A(A2),D0
		CMPI.B	#4,$1E(A2)		* el̓XLbv
		BLS	_SX1KBS_KC22
*
		MOVE.B	$1C(A2),D1		* rrf̂
		BEQ	_SX1KBS_KC22
_SX1KBS_KC21:
		LSR.W	#1,D0
		SUBQ.B	#1,D1
		BNE	_SX1KBS_KC21
_SX1KBS_KC22:
		CMP.W	KBS_KC2(A0),D0		* $B : KC2
		BEQ	_SX1KBS_P
		BSET.L	#$B,D6
		MOVE.W	D0,KBS_KC2(A0)

_SX1KBS_P:
		MOVE.W	KBS_KC2(A0),D0		* $3 : P
		SUB.W	KBS_KC1(A0),D0		* KC2-KC1
		CMPI.B	#4,$1E(A2)
		BLS	_SX1KBS_P2
		NEG.W	D0			* rrf̂
_SX1KBS_P2:
		CMP.W	KBS_P(A0),D0
		BEQ	_SX1KBS_LOOPE
		BSET.L	#3,D6
		MOVE.W	D0,KBS_P(A0)

* BEND 𔼕ɂ 97-04-23
		ASR.W	#1,D0
		MOVE.W	D0,T_BEND(A3)		* P: ̒lxhW

_SX1KBS_LOOPE:
		MOVE.W	D6,KBS_CHG(A0)		* ωtOZbg
		LEA.L	CHST(A0),A0		* next MMDSP CHANNEL BUFFER
		LEA.L	$20(A2),A2		* next SORCX1 WORK ADDRESS
		LEA.L	TRST(A3),A3		* next MMDSP TRACK BUFFER
		DBRA.W	D7,_SX1KBS_LOOP
		RTS

*
* SET KEYBOARD STATUS
*
SET_TRACK_STATUS:
		LEA.L	M_CH1(A5),A0
		LEA.L	TRACK_STATUS(A6),A3

		MOVEQ.L	#$00,D2			*gbNt󋵎o
		MOVEQ.L	#$00,D0
_SX1_TRK2:
		TST.B	$1F(A0)			* b7=ON:TRACK END
		BMI	_SX1_TRK22
		BTST.B	#6,$10(A0)		* b6=ON:MASK ON  OFF:MASK OFF
		BNE	_SX1_TRK22
		BSET.L	D0,D2
_SX1_TRK22:
		LEA.L	$20(A0),A0
		ADDQ.B	#1,D0
		CMPI.B	#8,D0
		BCS	_SX1_TRK2
*
		MOVE.L	TRACK_ENABLE(A6),D0
		MOVE.L	D2,TRACK_ENABLE(A6)
		EOR.L	D2,D0
		MOVE.L	D0,TRACK_CHANGE(A6)
* FM 1-5
		LEA.L	M_CH1(A5),A1
		LEA.L	KEYONWK(A6),A2
		LEA.L	TRACK_STATUS(A6),A3
		MOVEQ.L	#$00,D7			* FM 1-5
SET_TRACK_STATUS2:
		BSR	GET_TRACK_FM
		LEA.L	$20(A1),A1
		ADDQ.L	#2,A2
		LEA.L	TRST(A3),A3
		ADDQ.W	#1,D7
		CMPI.W	#$05,D7
		BCS	SET_TRACK_STATUS2

* SSG 1-3
SET_TRACK_STATUS3:
		BSR	GET_TRACK_SSG
		LEA.L	$20(A1),A1
		ADDQ.L	#2,A2
		LEA.L	TRST(A3),A3
		ADDQ.W	#1,D7
		CMPI.W	#$08,D7
		BCS	SET_TRACK_STATUS3
		RTS


*elgbNXe[^Xo
*	a0.l <- SORCX1 WORK AREA
*	a1.l <- CHANNEL WORK
*	a2.l <- keyon buffer address
*	a3.l <- TRACK_STATUS address

GET_TRACK_FM:
		MOVEQ.L	#$00,D5
		MOVE.L	D5,T_STCHANGE(A3)	* FLAG RESET

		MOVEQ.L	#$FF,D0			* FM PAN
		MOVE.B	$04(A1),D0
		ROL.B	#2,D0
		ANDI.W	#$FFF3,D0
		CMP.W	T_PAN(A3),D0
		BEQ	GET_TRACK_FM10
		BSET.L	#2,D5
		MOVE.W	D0,T_PAN(A3)

GET_TRACK_FM10:
		BSET.L	#1,D5			* FM BEND(DUMMY)

		MOVEQ.L	#$00,D0
		MOVE.B	$06(A1),D0		* $7 : @v1
		NEG.B	D0			* FM ̏ꍇ
		ADDI.B	#127,D0
		ANDI.B	#$7F,D0
		CMP.B	T_VELOCITY(A3),D0
		BEQ	GET_TRACK_FM51
		MOVE.B	#$01,T_VELCHANGE(A3)
		MOVE.B	D0,T_VELOCITY(A3)

GET_TRACK_FM51:
		MOVEQ.L	#$00,D0			* FM PROGRAM
		MOVE.B	$05(A1),D0
		CMP.W	T_PROGRAM(A3),D0
		BEQ	GET_TRACK_FM40
		MOVE.W	D0,T_PROGRAM(A3)
		BSET.L	#3,D5

GET_TRACK_FM40:
		BSR	FM_KEYONCHK
		BVS	GET_TRACK_FM60
		ST.B	D0
		SUBQ.B	#1,D0
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		MOVE.B	D0,T_KEYONSTAT(A3)
GET_TRACK_FM60:
		MOVE.B	$07(A1),D0		* NOTE.b 4hb OCTAVE
						*	 4lb NOTE
		CMP.B	T_KEYCODE(A3),D0	* FM KEYBOARD
		BEQ	GET_TRACK_FM90
		MOVE.B	#$01,T_KEYCHANGE(A3)
		ADDQ.B	#3,D0
		MOVE.B	D0,T_KEYCODE(A3)
GET_TRACK_FM90:
		MOVE.B	D5,T_STCHANGE(A3)
		RTS


*rrfgbNXe[^Xo
*	a1.l <- CHANNEL WORK
*	a2.l <- keyon buffer address
*	a3.l <- TRACK_STATUS address

GET_TRACK_SSG:
		MOVEQ.L	#$00,D5			* FLAG RESET
		MOVE.L	D5,T_STCHANGE(A3)

		MOVEQ.L	#$C0,D0			* SSG PAN(DUMMY)
		ROL.B	#2,D0
		CMP.W	T_PAN(A3),D0
		BEQ	GET_TRACK_SSG00
		BSET.L	#2,D5
		MOVE.W	D0,T_PAN(A3)

GET_TRACK_SSG00:
		BSET.L	#1,D5			* SSG BEND(DUMMY)

GET_TRACK_SSG10:
		MOVE.B	$06(A1),D0		* @v1
*		MOVE.B	$1D(A1),D0		* @v2
		ANDI.W	#$000F,D0
		LEA.L	SSG_TL_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_VELOCITY(A3),D0
		BEQ	GET_TRACK_SSG20
		MOVE.B	#$01,T_VELCHANGE(A3)
		MOVE.B	D0,T_VELOCITY(A3)
GET_TRACK_SSG20:
		MOVEQ.L	#$00,D0			* SSG PROGRAM
		MOVE.B	$05(A1),D0
		LSR.B	#4,D0
		ADDI.B	#100,D0
		CMP.W	T_PROGRAM(A3),D0
		BEQ	GET_TRACK_SSG30
		MOVE.W	D0,T_PROGRAM(A3)
		BSET.L	#3,D5
GET_TRACK_SSG30:
		BTST.B	#6,$10(A1)		* b6=ON:MASK ON  OFF:MASK OFF
		BNE	GET_TRACK_SSG32

		BSR	SSG_KEYONCHK
		BVS	GET_TRACK_SSG50
		ST.B	D0
		SUBQ.B	#1,D0
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		MOVE.B	D0,T_KEYONSTAT(A3)
		BRA	GET_TRACK_SSG50
* IF SSG MASK
GET_TRACK_SSG32:
		MOVE.B	#$01,T_KEYONCHANGE(A3)
		ST.B	T_KEYONSTAT(A3)

GET_TRACK_SSG50:
		MOVEQ.L	#$00,D0
		MOVE.B	$07(A1),D0
		LEA.L	KEY_TBL(PC),A0
		MOVE.B	(A0,D0.W),D0
		CMP.B	T_KEYCODE(A3),D0		* SSG KEYCODE
		BEQ	GET_TRACK_SSG90
		MOVE.B	#$01,T_KEYCHANGE(A3)
		MOVE.B	D0,T_KEYCODE(A3)

GET_TRACK_SSG90:
		MOVE.B	D5,T_STCHANGE(A3)
		RTS

*
* FM KEYON CHECK
*
* OUT	CCR : VS = SKIP KEYON FLAG CHANGE
*	      CC = KEYON
*
FM_KEYONCHK:
		TST.B	$1F(A1)
		BMI	KEYON_CHK3
		BTST.B	#0,$10(A1)		* REST
		BEQ	KEYON_CHK3
		CMPI.B	#$7F,$06(A1)
		BEQ	KEYON_CHK3
* CC : KEYON
		MOVE.B	$07(A1),D0
		ANDI.W	#$00FF,D0
		BSET.L	#8,D0
		CMP.W	(A2),D0
		BEQ	KEYON_CHK4		* EQ:NOT REWRITE
KEYON_CHK2:
		MOVE.W	D0,(A2)			* COPY KEYON KC
		ANDI.B	#$FE,CCR
		RTS

*
* SSG KEYON CHECK
*
* OUT	CCR : VS = SKIP KEYON FLAG CHANGE
*	      CC = KEYON
*
SSG_KEYONCHK:
		TST.B	$1F(A1)
		BMI	KEYON_CHK3
		TST.B	$1D(A1)
		BEQ	KEYON_CHK3
		TST.B	$04(A1)			* NOISE ON
		BPL	KEYON_CHK4
* CC : KEYON
		MOVE.B	$07(A1),D0
		ANDI.W	#$00FF,D0
		BSET.L	#8,D0
		CMP.W	(A2),D0
		BEQ	KEYON_CHK4		* EQ:NOT REWRITE
		MOVE.W	D0,(A2)			* COPY KEYON KC
		ANDI.B	#$FE,CCR
		RTS
KEYON_CHK3:
		CLR.W	(A2)
		ORI.B	#$02,CCR		* VS : SKIP
		RTS
KEYON_CHK4:
		BTST.B	#0,$0A(A1)		* TIE ON
		BNE	KEYON_CHK5
		CMPI.B	#$01,(A1)		* STEP COUNT PȉȂ KEYON 
		BLS	KEYON_CHK2
KEYON_CHK5:
		ORI.B	#$02,CCR		* VS : SKIP
		RTS

*
* GET TRACK MASK
*
SORCX1_GETMASK:
		MOVE.L	TRACK_ENABLE(A6),D0
		RTS

*
* GET SUPPORT FILE-EXT.
*
SORCX1_FILEEXT:
		PEA.L	FILEEXT_DAT(PC)			* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

FILEEXT_DAT:
		.DC.B	_SS,'SS',0
		.DC.B	_MPF,'MPF'
		.DC.B	0
		.EVEN

*
* CHECK & EXEC FILE-EXT.
*
SORCX1_FLOADP:
		MOVEM.L	D1/A1,-(SP)
		CMPI.B	#_SS,D0
		BEQ	SORCX1_OPN
		CMPI.B	#_MPF,D0
		BEQ	mxdrv_mpf
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$FF,D0
		RTS

SORCX1_OPN:
		MOVE.W	#0,-(SP)
		MOVE.L	A1,-(SP)
		DOS	_OPEN
		ADDQ.L	#6,SP
		MOVE.W	D0,D1
		BMI	SORCX1_LOADERR
		SORCSR	_M_STOP

		MOVEA.L	SORCX1_DATAADR(A6),A1
		PEA.L	$4000.W
		PEA.L	$D00(A1)
		MOVE.W	D1,-(SP)
		DOS	_READ
		DOS	_CLOSE
		LEA.L	10(SP),SP
		SORCSR	_M_PLAY_JUMP

		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$00,D0
		RTS

SORCX1_LOADERR:
		MOVEM.L	(SP)+,D1/A1
		MOVEQ.L	#$02,D0
		RTS

*
* PLAY
*
SORCX1_PLAY:
		SORCSR	_M_PLAY_JUMP
		RTS

*
* PAUSE / STOP
*
SORCX1_PAUSE:
SORCX1_STOP:
		SORCSR	_M_STOP
		RTS

*
* FADEOUT
*
SORCX1_FADEOUT:
		SORCSR	_M_FADEOUT
		RTS

*
* CONTINUE
*
SORCX1_CONT:
		SORCSR	_M_PLAY
*		RTS

*
* NO SUPPORT FUNCTIONS
*
SORCX1_SETMASK:
SORCX1_SKIP:
SORCX1_SLOW:
		RTS



		.END
